searchNodes=[{"doc":"Communication with a Phoenix Channels server.This module powers a process which can connect to a Phoenix Channels server and exchange messages with it. Currently, only websocket communication protocol is supported.The module is implemented as a behaviour. To use it, you need to implement the callback module. Then, you can invoke start_link/5 to start the socket process. The communication with the server is then controlled from that process.The connection is not automatically established during the creation. Instead, the implementation can return {:connect, state} to try to establish the connection. As the result either handle_connected/2 or handle_disconnected/2 callbacks will be invoked.To join a topic, join/3 function can be used. Depending on the result, either handle_joined/4 or handle_join_error/4 will be invoked. A client can join multiple topics on the same socket. It is also possible to leave a topic using the leave/3 function.Once a client has joined a topic, it can use push/4 to send messages to the server. If the server directly replies to the message, it will be handled in the handle_reply/5 callback.If a server sends an independent message (i.e. the one which is not a direct reply), the handle_message/5 callback will be invoked.If the server closes the channel, the handle_channel_closed/4 will be invoked. This will not close the socket connection, and the client can continue to communicate on other channels, or attempt to rejoin the channel.Sending messages over the socketAs mentioned, you can use join/3, push/4, and leave/3 to send messages to the server. All of these functions require the transport information as the first argument. This information is available in most of the callback functions.Functions will return {:ok, ref} if the message was sent successfully, or {:error, reason}, where ref is the Phoenix ref used to uniquely identify a message on a channel.Error responses are returned in following situations:The client is not connectedAttempt to send a message on a non-joined channelAttempt to leave a non-joined channelAttempt to join the already joined channelKeep in mind that there's no guarantee that a message will arrive to the server. You need to implement your own communication protocol on top of Phoenix Channels to obtain such guarantees.Process structure and lifecycleThe behaviour will internally start the websocket client in a separate child process. This means that the communication runs concurrently to any processing which takes place in the behaviour.The socket process will crash only if the websocket process crashes, which can be caused only by some bug in the websocket client library. If you want to survive this situation, you can simply trap exits in the socket process, by calling Process.flag(:trap_exit, true) in the init/1 callback. In this case, a crash of the websocket client process will be treated as a disconnect event.The socket process never decides to stop on its own. If you want to stop it, you can simply return {:stop, reason, state} from any of the callback.","ref":"Phoenix.Channels.GenSocketClient.html","title":"Phoenix.Channels.GenSocketClient","type":"behaviour"},{"doc":"Makes a synchronous call to the server and waits for its reply.","ref":"Phoenix.Channels.GenSocketClient.html#call/3","title":"Phoenix.Channels.GenSocketClient.call/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Phoenix.Channels.GenSocketClient.html#child_spec/1","title":"Phoenix.Channels.GenSocketClient.child_spec/1","type":"function"},{"doc":"Invoked to handle a synchronous call.","ref":"Phoenix.Channels.GenSocketClient.html#c:handle_call/4","title":"Phoenix.Channels.GenSocketClient.handle_call/4","type":"callback"},{"doc":"Invoked after the server closes a channel.","ref":"Phoenix.Channels.GenSocketClient.html#c:handle_channel_closed/4","title":"Phoenix.Channels.GenSocketClient.handle_channel_closed/4","type":"callback"},{"doc":"Invoked after the client has successfully connected to the server.","ref":"Phoenix.Channels.GenSocketClient.html#c:handle_connected/2","title":"Phoenix.Channels.GenSocketClient.handle_connected/2","type":"callback"},{"doc":"Invoked after the client has been disconnected from the server.","ref":"Phoenix.Channels.GenSocketClient.html#c:handle_disconnected/2","title":"Phoenix.Channels.GenSocketClient.handle_disconnected/2","type":"callback"},{"doc":"Invoked to handle an Erlang message.","ref":"Phoenix.Channels.GenSocketClient.html#c:handle_info/3","title":"Phoenix.Channels.GenSocketClient.handle_info/3","type":"callback"},{"doc":"Invoked if the server has refused a topic join request.","ref":"Phoenix.Channels.GenSocketClient.html#c:handle_join_error/4","title":"Phoenix.Channels.GenSocketClient.handle_join_error/4","type":"callback"},{"doc":"Invoked after the client has successfully joined a topic.","ref":"Phoenix.Channels.GenSocketClient.html#c:handle_joined/4","title":"Phoenix.Channels.GenSocketClient.handle_joined/4","type":"callback"},{"doc":"Invoked when a message from the server arrives.","ref":"Phoenix.Channels.GenSocketClient.html#c:handle_message/5","title":"Phoenix.Channels.GenSocketClient.handle_message/5","type":"callback"},{"doc":"Invoked when the server replies to a message sent by the client.","ref":"Phoenix.Channels.GenSocketClient.html#c:handle_reply/5","title":"Phoenix.Channels.GenSocketClient.handle_reply/5","type":"callback"},{"doc":"Invoked when the process is created.","ref":"Phoenix.Channels.GenSocketClient.html#c:init/1","title":"Phoenix.Channels.GenSocketClient.init/1","type":"callback"},{"doc":"Joins the topic.","ref":"Phoenix.Channels.GenSocketClient.html#join/3","title":"Phoenix.Channels.GenSocketClient.join/3","type":"function"},{"doc":"Returns true if the socket is joined on the given topic.This function should be invoked from the GenSocketClient process.","ref":"Phoenix.Channels.GenSocketClient.html#joined?/1","title":"Phoenix.Channels.GenSocketClient.joined?/1","type":"function"},{"doc":"Leaves the topic.","ref":"Phoenix.Channels.GenSocketClient.html#leave/3","title":"Phoenix.Channels.GenSocketClient.leave/3","type":"function"},{"doc":"Notifies the socket process that the connection has been established.","ref":"Phoenix.Channels.GenSocketClient.html#notify_connected/1","title":"Phoenix.Channels.GenSocketClient.notify_connected/1","type":"function"},{"doc":"Notifies the socket process about a disconnect.","ref":"Phoenix.Channels.GenSocketClient.html#notify_disconnected/2","title":"Phoenix.Channels.GenSocketClient.notify_disconnected/2","type":"function"},{"doc":"Forwards a received message to the socket process.","ref":"Phoenix.Channels.GenSocketClient.html#notify_message/2","title":"Phoenix.Channels.GenSocketClient.notify_message/2","type":"function"},{"doc":"Pushes a message to the topic.","ref":"Phoenix.Channels.GenSocketClient.html#push/4","title":"Phoenix.Channels.GenSocketClient.push/4","type":"function"},{"doc":"Can be invoked to send a response to the client.","ref":"Phoenix.Channels.GenSocketClient.html#reply/2","title":"Phoenix.Channels.GenSocketClient.reply/2","type":"function"},{"doc":"Starts the socket process.","ref":"Phoenix.Channels.GenSocketClient.html#start_link/5","title":"Phoenix.Channels.GenSocketClient.start_link/5","type":"function"},{"doc":"Optional callback invoked when the server is about to exit. It should do any cleanup required.","ref":"Phoenix.Channels.GenSocketClient.html#c:terminate/2","title":"Phoenix.Channels.GenSocketClient.terminate/2","type":"callback"},{"doc":"","ref":"Phoenix.Channels.GenSocketClient.html#t:callback_state/0","title":"Phoenix.Channels.GenSocketClient.callback_state/0","type":"type"},{"doc":"","ref":"Phoenix.Channels.GenSocketClient.html#t:encoded_message/0","title":"Phoenix.Channels.GenSocketClient.encoded_message/0","type":"type"},{"doc":"","ref":"Phoenix.Channels.GenSocketClient.html#t:event/0","title":"Phoenix.Channels.GenSocketClient.event/0","type":"type"},{"doc":"","ref":"Phoenix.Channels.GenSocketClient.html#t:handler_response/0","title":"Phoenix.Channels.GenSocketClient.handler_response/0","type":"type"},{"doc":"","ref":"Phoenix.Channels.GenSocketClient.html#t:message/0","title":"Phoenix.Channels.GenSocketClient.message/0","type":"type"},{"doc":"","ref":"Phoenix.Channels.GenSocketClient.html#t:out_payload/0","title":"Phoenix.Channels.GenSocketClient.out_payload/0","type":"type"},{"doc":"","ref":"Phoenix.Channels.GenSocketClient.html#t:payload/0","title":"Phoenix.Channels.GenSocketClient.payload/0","type":"type"},{"doc":"","ref":"Phoenix.Channels.GenSocketClient.html#t:query_params/0","title":"Phoenix.Channels.GenSocketClient.query_params/0","type":"type"},{"doc":"","ref":"Phoenix.Channels.GenSocketClient.html#t:ref/0","title":"Phoenix.Channels.GenSocketClient.ref/0","type":"type"},{"doc":"","ref":"Phoenix.Channels.GenSocketClient.html#t:socket_opts/0","title":"Phoenix.Channels.GenSocketClient.socket_opts/0","type":"type"},{"doc":"","ref":"Phoenix.Channels.GenSocketClient.html#t:topic/0","title":"Phoenix.Channels.GenSocketClient.topic/0","type":"type"},{"doc":"","ref":"Phoenix.Channels.GenSocketClient.html#t:transport/0","title":"Phoenix.Channels.GenSocketClient.transport/0","type":"opaque"},{"doc":"","ref":"Phoenix.Channels.GenSocketClient.html#t:transport_opts/0","title":"Phoenix.Channels.GenSocketClient.transport_opts/0","type":"type"},{"doc":"Describes the serializer interface used in Phoenix.Channels.GenSocketClient to encode/decode messages.","ref":"Phoenix.Channels.GenSocketClient.Serializer.html","title":"Phoenix.Channels.GenSocketClient.Serializer","type":"behaviour"},{"doc":"Invoked to decode the raw message.","ref":"Phoenix.Channels.GenSocketClient.Serializer.html#c:decode_message/1","title":"Phoenix.Channels.GenSocketClient.Serializer.decode_message/1","type":"callback"},{"doc":"Invoked to encode a socket message.","ref":"Phoenix.Channels.GenSocketClient.Serializer.html#c:encode_message/1","title":"Phoenix.Channels.GenSocketClient.Serializer.encode_message/1","type":"callback"},{"doc":"Gzip+Json serializer for the socket client.","ref":"Phoenix.Channels.GenSocketClient.Serializer.GzipJson.html","title":"Phoenix.Channels.GenSocketClient.Serializer.GzipJson","type":"module"},{"doc":"Json serializer for the socket client.","ref":"Phoenix.Channels.GenSocketClient.Serializer.Json.html","title":"Phoenix.Channels.GenSocketClient.Serializer.Json","type":"module"},{"doc":"A simple synchronous Phoenix Channels client.This module can be used in your project for testing your own functionality. The module implements the Phoenix.Channels.GenSocketClient behaviour to provide a controllable API for channel clients. The implementation is very basic, and is useful for tests only. It's not advised to use this module in production, because there are various edge cases which can cause subtle bugs. You're instead advised to implement your own callback for the Phoenix.Channels.GenSocketClient behaviour.","ref":"Phoenix.Channels.GenSocketClient.TestSocket.html","title":"Phoenix.Channels.GenSocketClient.TestSocket","type":"module"},{"doc":"Awaits a message from the socket.","ref":"Phoenix.Channels.GenSocketClient.TestSocket.html#await_message/2","title":"Phoenix.Channels.GenSocketClient.TestSocket.await_message/2","type":"function"},{"doc":"Connect to the server.","ref":"Phoenix.Channels.GenSocketClient.TestSocket.html#connect/1","title":"Phoenix.Channels.GenSocketClient.TestSocket.connect/1","type":"function"},{"doc":"Connect to the server and override/replace the initialized url and query params.","ref":"Phoenix.Channels.GenSocketClient.TestSocket.html#connect/3","title":"Phoenix.Channels.GenSocketClient.TestSocket.connect/3","type":"function"},{"doc":"Joins a topic on the connected socket.","ref":"Phoenix.Channels.GenSocketClient.TestSocket.html#join/4","title":"Phoenix.Channels.GenSocketClient.TestSocket.join/4","type":"function"},{"doc":"Returns true if the socket is joined on the given topic.","ref":"Phoenix.Channels.GenSocketClient.TestSocket.html#joined?/2","title":"Phoenix.Channels.GenSocketClient.TestSocket.joined?/2","type":"function"},{"doc":"Leaves the topic.","ref":"Phoenix.Channels.GenSocketClient.TestSocket.html#leave/4","title":"Phoenix.Channels.GenSocketClient.TestSocket.leave/4","type":"function"},{"doc":"Pushes a message to the topic.","ref":"Phoenix.Channels.GenSocketClient.TestSocket.html#push/5","title":"Phoenix.Channels.GenSocketClient.TestSocket.push/5","type":"function"},{"doc":"Pushes a message to the topic and awaits the direct response from the server.","ref":"Phoenix.Channels.GenSocketClient.TestSocket.html#push_sync/5","title":"Phoenix.Channels.GenSocketClient.TestSocket.push_sync/5","type":"function"},{"doc":"Starts the driver process.","ref":"Phoenix.Channels.GenSocketClient.TestSocket.html#start_link/5","title":"Phoenix.Channels.GenSocketClient.TestSocket.start_link/5","type":"function"},{"doc":"Waits until the socket is connected or disconnected","ref":"Phoenix.Channels.GenSocketClient.TestSocket.html#wait_connect_status/2","title":"Phoenix.Channels.GenSocketClient.TestSocket.wait_connect_status/2","type":"function"},{"doc":"Transport contract used by Phoenix.Channels.GenSocketClientThe implementation has following responsibilities:Starts the transport process and links it to the caller. It is always assumed that the caller process is the socket process.Pushes messages to the server when the push/2 function is invoked.Notifies the socket process about various events by invoking notify_* functions from the Phoenix.Channels.GenSocketClient module.","ref":"Phoenix.Channels.GenSocketClient.Transport.html","title":"Phoenix.Channels.GenSocketClient.Transport","type":"behaviour"},{"doc":"Invoked to push the frame.","ref":"Phoenix.Channels.GenSocketClient.Transport.html#c:push/2","title":"Phoenix.Channels.GenSocketClient.Transport.push/2","type":"callback"},{"doc":"Invoked from the socket process to start the transport process.","ref":"Phoenix.Channels.GenSocketClient.Transport.html#c:start_link/2","title":"Phoenix.Channels.GenSocketClient.Transport.start_link/2","type":"callback"},{"doc":"","ref":"Phoenix.Channels.GenSocketClient.Transport.html#t:frame/0","title":"Phoenix.Channels.GenSocketClient.Transport.frame/0","type":"type"},{"doc":"","ref":"Phoenix.Channels.GenSocketClient.Transport.html#t:transport_pid/0","title":"Phoenix.Channels.GenSocketClient.Transport.transport_pid/0","type":"type"},{"doc":"Websocket transport powered by the websocket_client library.Supported transport options:keepalive - Interval in which a ping message is sent to the server to keep the connection alive. By default, Phoenix server will timeout after 60 seconds of inactivity. By providing a keepalive value which is less than the server timeout, you can ensure that the connection remains open, even if no messages are being passed between the client and the server. If you don't want to disable this mechanism, you can pass nil. If this option is not provided, the default value of 30 seconds is used.extra_headers - List of headers to send in the handshake. It will be forwarded as is to the underlying library.ssl_verify - It will be forwarded as is to the underlying library.","ref":"Phoenix.Channels.GenSocketClient.Transport.WebSocketClient.html","title":"Phoenix.Channels.GenSocketClient.Transport.WebSocketClient","type":"module"},{"doc":"phoenix_gen_socket_client This library implements an Elixir client for Phoenix Channels protocol 2.x. The client is implemented as a behaviour, which allows a lot of flexibility. For an alternative approach, you may also want to check this project.NOTE: From version 2.0 onwards this library only supports version 2.0 of the channels protocol (used on Phoenix 1.3 or later). If you need to use the version 1.0 of the protocol, you need to use the older version of this library.","ref":"readme.html","title":"phoenix_gen_socket_client","type":"extras"},{"doc":"This library is continuously used in our system and it's been working for us, so we consider it to be stable :-)","ref":"readme.html#status","title":"phoenix_gen_socket_client - Status","type":"extras"},{"doc":"You need to add the project as a dependency to your mix.exs: def project do [ deps: [ {:phoenix_gen_socket_client, &quot;~&gt; 3.0.0&quot;} # ... ], # ... ] endYou also need to add the transport (e.g. a websocket client), and serializer (e.g. JSON) as dependencies. Out of the box, the adapter for sanmiguel/websocket_client, and support for Jason is provided but you still need to include the libraries yourself:def project do [ deps: [ {:websocket_client, &quot;~&gt; 1.2&quot;}, {:jason, &quot;~&gt; 1.1&quot;} # ... ], # ... ] end","ref":"readme.html#prerequisites","title":"phoenix_gen_socket_client - Prerequisites","type":"extras"},{"doc":"This library is designed for flexibility, so the usage is a bit more involved. In general, you need to:Implement a callback module for the Phoenix.Channels.GenSocketClient behaviour.Start the socket process somewhere in your supervision tree.Interact with the server from callback functions which are running in the socket process.A simple demo is available here. Here, we'll present some general ideas. For more details, refer to the documentation.Note: In the subsequent code snippets we assume that Phoenix.Channels.GenSocketClient is aliased, so we use GenSocketClient.Starting the socket processStarting the process works similar to other behaviours, such as GenServer:GenSocketClient.start_link( callback_module, transport_module, arbitrary_argument, socket_opts, # defaults to [] gen_server_opts # defaults to [] )For transport_module you can pass any module which implements the Phoenix.Channels.GenSocketClient.Transport behaviour. Out of the box, you have the module Phoenix.Channels.GenSocketClient.Transport.WebSocketClient available.The code above will start another process where the init/1 function of the callback_module is invoked. This function needs to provide the initial state and the socket url. The tuple also determines whether the connection will be immediately established or not.The socket url must also include the transport suffix. For example, if in the server socket you have declared socket with socket &quot;/my_socket&quot;, ..., then the url for the websocket transport would be ws://server_url/my_socket/websocket.Connection life-cycleIf init/1 returns {:connect, url, query_params, initial_state} the socket process will try to connect to the server. The connection is established in a separate process which we call the transport process. This process is the immediate child of the socket process. As a consequence, all communication takes place concurrently to the socket process. If you handle Erlang messages in the socket process you may need to keep track of whether you're connected or not.The establishing of the connection is done asynchronously. The handle_connected/2 callback is invoked after the connection is established. The handle_disconnected/2 callback is invoked if establishing the connection fails or an existing connection is lost.If the connection is not established (or dropped), you can reconnect from handle_* functions by returning {:connect, state} tuple. In this case the workflow is the same as when returning the :connect tuple from the init/1 callback.You may also decide to defer connecting to a later point in time by returning {:noconnect, url, query_params, state} from the init/1 callback. To later establish a connection you need to send some message to the socket process, and handle that message in handle_info by returning the {:connect, state} tuple.You may also return {:connect, url, query_params, state} from a handle_info callback to connect (or reconnect) the socket to a different location or with different params than it started with.Though somewhat elaborate, this approach has following benefits:The socket process starts immediately without waiting for the connection to be established.The socket process can live in the supervision tree even if the connection is not established.Implementing reconnection logic is very flexible. You can trigger a reconnect directly from handle_disconnected/2, or send yourself a delayed message. You can also easily accumulate outgoing messages until you reconnect, or you can attempt a finite number of reconnects and then give up.Sending messages over a socketOnce you're connected to the socket, you can issue messages. Most handle_* callbacks receive a transport argument. You can pass this argument to functions such as GenSocketClient.join/3, GenSocketClient.leave/3, GenSocketClient.push/4 to send messages over a connected socket. If you're disconnected when calling these functions, they will return an error. Otherwise they return a successful response.Of course, there's no guarantees that the message has arrived to the server, since a netsplit can happen at any point in time.Channel life-cycleTo join a topic, you can use GenSocketClient.join/3. Depending on the outcome, handle_joined/4 or handle_join_error/4 callback is invoked. If the server leaves the channel at some later point, handle_channel_closed/4 callback will be invoked. Just like with socket connections, this gives you a lot of flexibility if you want to implement the rejoin logic. On socket disconnect, all channels are closed, but handle_channel_closed/4 is not invoked.You can of course join multiple topics on the same socket. Unlike in Phoenix, all messages are handled in the socket process. Besides the socket and the transport process, there are no additional processes created. Such decisions are deliberately left out of the GenSocketClient to support more flexibility.Communicating on a channelTo send a message on the connected channel, you can use GenSocketClient.push/4. If the socket has not joined the topic, an error is returned. On success, the message reference (aka ref) is returned.If the server-side channel replies directly (using the {:reply, ...}), the handle_reply/5 callback is invoked with the matching ref. Refs are unique only per channel-session. Two channels can use the same refs. Also, refs can be reused after you rejoin a topic.If the server sends an asynchronous message (i.e. not a direct reply), the handle_message/5 callback is invoked.","ref":"readme.html#usage","title":"phoenix_gen_socket_client - Usage","type":"extras"},{"doc":"Copyright (c) 2020 AircloakThe source code is licensed under the MIT License.","ref":"readme.html#copyright-and-license","title":"phoenix_gen_socket_client - Copyright and License","type":"extras"}]